require "import"

import "android.view.WindowManager"
import "android.view.Gravity"
import "android.graphics.PixelFormat"
import "android.view.KeyEvent"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "android.view.View"
import "android.widget.Toast"
import "android.widget.EditText"

function shareWithTelegram()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      local telegramPackages = {
        "org.telegram.messenger",
        "org.telegram.messenger.web",
        "org.telegram.messenger.beta"
      }
      local found = false
      for _, pkg in ipairs(telegramPackages) do
        intent.setPackage(pkg)
        if this.getPackageManager().resolveActivity(intent, 0) then
          pcall(function() this.startActivity(intent) end)
          found = true
          break
        end
      end
      if not found then
        print("لم يتم العثور على تطبيق تيليغرام.")
      end
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end





-- مشاركة مع واتساب
function shareWithWhatsApp()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      intent.setPackage("com.whatsapp")
      pcall(function() this.startActivity(intent) end)
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end

-- مشاركة مع واتساب للأعمال
function shareWithWhatsAppBusiness()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      intent.setPackage("com.whatsapp.w4b")
      pcall(function() this.startActivity(intent) end)
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end

-- مشاركة مع فايبر
function shareWithViber()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      intent.setPackage("com.viber.voip")
      pcall(function() this.startActivity(intent) end)
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end

-- مشاركة مع ماسنجر
function shareWithMessenger()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      intent.setPackage("com.facebook.orca")
      pcall(function() this.startActivity(intent) end)
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end

-- مشاركة مع فيسبوك
function shareWithFacebook()
  task(1800, function()
    local editBox = loadlayout({EditText})
    editBox.setHint("رابط المشاركة")
    editBox.setBackgroundColor(0xFF000000)
    local dialog = LuaDialog()
    dialog.setView(editBox)
    dialog.setButton("مشاركة", function()
      local text = tostring(editBox.getText()):match("^%s*(.-)%s*$")
      local intent = Intent(Intent.ACTION_SEND)
      intent.setType("text/plain")
      intent.putExtra(Intent.EXTRA_TEXT, text)
      intent.setPackage("com.facebook.katana")
      pcall(function() this.startActivity(intent) end)
    end)
    dialog.show()
  end)
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "رابط المشاركة@*>10$100","%coller$100","#button1",}})
end




function searchYouTubeVoAr()
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper") -- تم إضافة هذا السطر لاستدعاء Looper
  local Handler = luajava.bindClass("android.os.Handler") -- تأكد من استدعاء Handler بشكل صحيح أيضاً
  local Uri = luajava.bindClass("android.net.Uri") -- تم إضافة Uri
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "عربي" then
            this.postSpeak(200, "إِبْحَثْ في YouTube")
            require "import"
            task(1800, function()
              searchYouTubeAr()
            end)
            return
           elseif text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           else
            this.postSpeak(200,"جاري البحث عن "..text)
            require "import"
            task(3500, function()
              local searchUrl = "https://www.youtube.com/results?search_query=" .. Uri.encode(text)
              local intent = Intent(Intent.ACTION_VIEW, Uri.parse(searchUrl))
              activity.startActivity(intent)
            end)
          end
        end
      end,
      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
      -- يمكنك إضافة المزيد من الحالات الخاصة بـ onReadyForSpeech وغيرها إذا أردت
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  startVoiceRecognition(activity)
end









service.setUpTap(true)






local layout = LinearLayout(this)
layout.setOrientation(LinearLayout.VERTICAL)
layout.setBackgroundColor(0xAA000000) -- لون أسود أقل شفافية (أكثر وضوحًا)
layout.setFocusable(true)
layout.setFocusableInTouchMode(true)

local params = WindowManager.LayoutParams()
params.type = WindowManager.LayoutParams.TYPE_ACCESSIBILITY_OVERLAY
params.format = PixelFormat.TRANSLUCENT

params.flags = WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL
params.flags = bit32.bor(params.flags, WindowManager.LayoutParams.FLAG_WATCH_OUTSIDE_TOUCH)
-- لا تضف FLAG_NOT_FOCUSABLE

params.gravity = Gravity.TOP | Gravity.START
params.width = WindowManager.LayoutParams.MATCH_PARENT
params.height = WindowManager.LayoutParams.MATCH_PARENT
params.x = 0
params.y = 0

local wm = this.getSystemService("window")

function hideMenu()
  pcall(function() wm.removeView(layout) end)
end

local items = {
  {text="تسريع", action=function() service.setUpTap(false) hideMenu()
service.click({{ {{"#floaty_bar_controls_view", {{"#hide_controls_button_top$100","<#watch_player$100","%pression prolongée et maintenue",}, {"<#watch_player$100","%pression prolongée et maintenue",}},}, {"#hide_controls_button_top$100","<#watch_player$100","%pression prolongée et maintenue",}, {"<#watch_player$100","%pression prolongée et maintenue",}, {}} }})
end},
  {text="1.0", action=function() service.setUpTap(false) hideMenu()
service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "1,0|1.0>10$100", "%Retour",}, {"#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "1,0|1.0>10$100", "%Retour",}},}}, }})
 end},
  {text="1.5", action=function() service.setUpTap(false) hideMenu()
service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "1,5|1.5>10$100", "%Retour",}, {"#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "1,5|1.5>10$100", "%Retour",}},}}, }})
 end},
{text="2.0", action=function() service.setUpTap(false) hideMenu()
service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "2,0|2.0>10$100", "%Retour",}, {"#player_overflow_button>10$100", "Vitesse*|سرعة*>10$100", "2,0|2.0>10$100", "%Retour",}},}}, }})
 end},
{text="البحث الصوتي", action=function()
service.setUpTap(false) hideMenu()
  this.postSpeak(200, "إِبْحَثْ في YouTube")
  require "import"
  task(1800, function()
    searchYouTubeVoAr()
  end)
end},
{text="مشاركه", action=function()  service.setUpTap(false) hideMenu()
  service.click({{"مشاركة|Partager|مشاركة هذا الفيديو|Partager cette vidéo$100","مشاركة|Partager>900","%éléments suivants$٧00","%Dernier élément","Plus|المزيد>5",}})
end},
{text="وصف الفيديو", action=function()  service.setUpTap(false) hideMenu()
   function describeVideo()
    require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
    return true
  end
  service.click({{"Partager|مشاركة|مشاركة هذا الفيديو|Partager cette vidéo$100","Copier le lien|نسخ الرابط>10", "%describeVideo$200", "<#assistant_robin_floaty_single_line_query>10$200","%coller$600", "#assistant_robin_send_icon_button$2000", "<#com.google.android.googlequicksearchbox:id/assistant_robin_text#1>50",}})
end},
{text="تعليق", action=function()  service.setUpTap(false) hideMenu()
  if service.click({{"Ajoutez un commentaire*|إضافة تعليق*",}})
   elseif service.click({{"*التعليقات*|*Commentaires*|*تعليقًا$200", "Ajoutez un commentaire*|إضافة تعليق*|مشاركة أفكارك*>10",}})
  end
end},
{text="ضعيفة", action=function()  service.setUpTap(false) hideMenu()
  service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","144*|240*|360*$100",}, {"144*|240*|360*$100",}},}, {"#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","144*|240*|360*$100",}, {"144*|240*|360*$100",}}, }},}}, }})
end},
{text="متوسطة", action=function()  service.setUpTap(false) hideMenu()
  service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","720*|480*|360*$100",}, {"720*|480*|360*$100",}},}, {"#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","720*|480*|360*$100",}, {"720*|480*|360*$100",}}, }},}}, }})
end},
{text="عالية", action=function()  service.setUpTap(false) hideMenu()
  service.click({{ {{"#floaty_bar_controls_view$100", {{"#watch_player", "#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","2160*|1440*|1080*|720*|480*$100",}, {"2160*|1440*|1080*|720*|480*$100",}},}, {"#player_overflow_button>10$100", "Qualité*|الجودة*>10$100", {{"خيارات متقدّمة*|Avancée*","2160*|1440*|1080*|720*|480*$100",}, {"2160*|1440*|1080*|720*|480*$100",}}, }},}}, }})
end},
{text="ملء الشاشه", action=function()  service.setUpTap(false) hideMenu()
  if service.click({{"#fullscreen_button",}})
   elseif service.click({{"#watch_player$100","#fullscreen_button>10",}})
  end
end},
{text="اظهار", action=function()  service.setUpTap(false) hideMenu()
  if service.click({{"#watch_player",}})
   elseif service.click({{"#floaty_bar_controls_view$100", "#watch_player>10",}})
  end
end},
{text="اخفاء", action=function()  service.setUpTap(false) hideMenu()
  if service.click({{"#hide_controls_button_top",}})
   elseif service.click({{"#floaty_bar_controls_view$100","#hide_controls_button_top>4",}})
  end
end},
{text="إغلاق", action=function()  service.setUpTap(false) hideMenu()
  service.click({{{{{"#modern_miniplayer_close","#floaty_close_button",}, }, {"%Retour$500", {"#modern_miniplayer_close","#floaty_close_button",}}},}})
end},
{text="Telegram", action=function()  service.setUpTap(false) hideMenu()shareWithTelegram() end},
{text="WhatsApp", action=function()  service.setUpTap(false) hideMenu()shareWithWhatsApp() end},
{text="WhatsApp Business", action=function()  service.setUpTap(false) hideMenu()shareWithWhatsAppBusiness() end},
{text="Viber", action=function()  service.setUpTap(false) hideMenu()shareWithViber() end},
{text="Messenger", action=function()  service.setUpTap(false) hideMenu()shareWithMessenger() end},
{text="Facebook", action=function()  service.setUpTap(false) hideMenu()shareWithFacebook() end}
}

function createItem(text, callback, weight)
  local tv = TextView(this)
  tv.setText(text)
  tv.setContentDescription(text)
  tv.setImportantForAccessibility(View.IMPORTANT_FOR_ACCESSIBILITY_YES)
  tv.setFocusable(true)
  tv.setClickable(true)
  tv.setTextSize(20)
  tv.setPadding(30, 30, 30, 30)
  tv.setBackgroundColor(0x22000000)
  tv.setTextColor(0xffffffff)
tv.setGravity(Gravity.CENTER)
  local params = LinearLayout.LayoutParams(-1, 0)
  params.weight = weight
  tv.setLayoutParams(params)
  tv.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      callback()
    end
  })
  return tv
end

local itemCount = #items + 1

for i, item in ipairs(items) do
  layout.addView(createItem(item.text, item.action, 1/itemCount))
end

layout.addView(createItem("الخروج", function()
service.setUpTap(false)
  Toast.makeText(this,"تم الخروج",Toast.LENGTH_SHORT).show()
  hideMenu()
end, 1/itemCount))

wm.addView(layout, params)

layout.setOnKeyListener(View.OnKeyListener{
  onKey = function(view, keyCode, event)
    if keyCode == KeyEvent.KEYCODE_BACK and event.getAction() == KeyEvent.ACTION_UP then
      hideMenu()
service.setUpTap(false)
      return true
    end
    return false
  end
})

layout.requestFocus()